package com.viettel.campaign.repository.impl;

import com.viettel.campaign.repository.CampaignExecuteRepository;
import com.viettel.campaign.utils.Constants;
import com.viettel.campaign.utils.DataUtil;
import com.viettel.campaign.utils.HibernateUtil;
import com.viettel.campaign.utils.SQLBuilder;
import com.viettel.campaign.web.dto.ApParamDTO;
import com.viettel.campaign.web.dto.ContactCustResultDTO;
import com.viettel.campaign.web.dto.ResultDTO;
import com.viettel.campaign.web.dto.request_dto.CampaignRequestDTO;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.transform.Transformers;
import org.hibernate.type.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import java.util.*;
import java.util.concurrent.TimeUnit;

@Repository
public class CampaignExecuteRepositoryImp implements CampaignExecuteRepository {

    private static final Logger logger = LoggerFactory.getLogger(CampaignRepositoryImpl.class);

    @Autowired
    NamedParameterJdbcTemplate namedParameterJdbcTemplate;

    @Autowired
    EntityManager entityManager;

    @Override
    public List<ApParamDTO> getComboBoxStatus(String companySiteId, String completeType) {
        List<ApParamDTO> list = new ArrayList<>();
        Map<String, String> params = new HashMap<>();
        String sql = SQLBuilder.getSqlQueryById(Constants.SQL_MODULES.MODULE_EXECUTE, "get-combo-status");
        try {
            params.put("p_company_site_id", companySiteId);
            params.put("p_complete_type", completeType);
            list = namedParameterJdbcTemplate.query(sql, params, BeanPropertyRowMapper.newInstance(ApParamDTO.class));
        } catch (Exception e) {
            logger.error(e.getMessage(), e);
        }
        return list;
    }

    @Override
    public List<ApParamDTO> getComboCampaignType(String companySiteId) {
        List<ApParamDTO> list = new ArrayList<>();
        Map<String, String> params = new HashMap<>();
        String sql = SQLBuilder.getSqlQueryById(Constants.SQL_MODULES.MODULE_EXECUTE, "get-combo-campaign-type");
        try {
            params.put("p_company_site_id", companySiteId);
            list = namedParameterJdbcTemplate.query(sql, params, BeanPropertyRowMapper.newInstance(ApParamDTO.class));
        } catch (Exception e) {
            logger.error(e.getMessage(), e);
        }
        return list;
    }

    @Override
    public ResultDTO getInteractiveResult(CampaignRequestDTO dto) {
        ResultDTO resultDTO = new ResultDTO();
        List<ContactCustResultDTO> list = new ArrayList<>();
        SessionFactory sessionFactory = HibernateUtil.getSessionFactory();
        Session session = sessionFactory.openSession();
        session.beginTransaction();

        StringBuilder sqlBuilder = new StringBuilder();
        try {
            String sql = SQLBuilder.getSqlQueryById(Constants.SQL_MODULES.MODULE_EXECUTE, "get-execute-interactive");
            sqlBuilder.append(sql);

            sqlBuilder.append(" and b.campaign_type in (:p_list_compaign_type)");
            sqlBuilder.append(" and to_char(a.customer_id) like :p_customer_id");
            sqlBuilder.append(" and to_char(a.contact_status) in (:p_list_contact_status)");
            sqlBuilder.append(" and to_char(a.call_status) in (:p_list_survey_status)");
            sqlBuilder.append(" and to_char(a.status) in (:p_list_record_status)");

            if (!DataUtil.isNullOrEmpty(dto.getPhoneNumber())) {
                sqlBuilder.append(" and a.phone_number like :p_phone_number");
            }
            if (!DataUtil.isNullOrEmpty(dto.getCampaignId())) {
                sqlBuilder.append(" and b.campaign_code in (:p_list_campaign_id) ");
            }
            if (!DataUtil.isNullOrEmpty(dto.getCampaignName())) {
                sqlBuilder.append(" and upper(b.campaign_name) like :p_campaign_name");
            }
            if (!DataUtil.isNullOrEmpty(dto.getAgentId())) {
                sqlBuilder.append(" and upper(c.user_name) like :p_user_name");
            }

            SQLQuery query = session.createSQLQuery(sqlBuilder.toString());

            query.setParameter("p_company_site_id", dto.getCompanySiteId());
            query.setParameter("p_customer_id", "%" + dto.getCustomerId()
                    .replace("\\", "\\\\")
                    .replaceAll("%", "\\%")
                    .replaceAll("_", "\\_")
            + "%");
            query.setParameter("p_date_from", dto.getFromDate());
            query.setParameter("p_date_to", dto.getToDate());
            query.setParameterList("p_list_compaign_type", dto.getCampaignType().split(","));
            query.setParameterList("p_list_contact_status", dto.getContactStatus().split(","));
            query.setParameterList("p_list_survey_status", dto.getSurveyStatus().split(","));
            query.setParameterList("p_list_record_status", dto.getRecordStatus().split(","));
            query.setParameter("p_call_time_from", dto.getCallTimeFrom());
            query.setParameter("p_call_time_to", dto.getCallTimeTo());

            if (!DataUtil.isNullOrEmpty(dto.getCampaignId())) {
                query.setParameterList("p_list_campaign_id", dto.getCampaignId().split(","));
            }
            if (!DataUtil.isNullOrEmpty(dto.getPhoneNumber())) {
                query.setParameter("p_phone_number", "%" + dto.getPhoneNumber()
                        .replace("\\", "\\\\")
                        .replaceAll("%", "\\%")
                        .replaceAll("_", "\\_")
                        + "%");
            }
            if (!DataUtil.isNullOrEmpty(dto.getCampaignName())) {
                query.setParameter("p_campaign_name", "%" + dto.getCampaignName().toUpperCase()
                        .replace("\\", "\\\\")
                        .replaceAll("%", "\\%")
                        .replaceAll("_", "\\_")
                        + "%");
            }
            if (!DataUtil.isNullOrEmpty(dto.getAgentId())) {
                query.setParameter("p_user_name", "%" + dto.getAgentId().toUpperCase()
                        .replace("\\", "\\\\")
                        .replaceAll("%", "\\%")
                        .replaceAll("_", "\\_")
                + "%");
            }

            query.addScalar("campaignCode", new StringType());
            query.addScalar("campaignName", new StringType());
            query.addScalar("userName", new StringType());
            query.addScalar("phoneNumber", new StringType());
            query.addScalar("customerName", new StringType());
            query.addScalar("createTime", new DateType());
            query.addScalar("contactStatus", new StringType());
            query.addScalar("surveyStatus", new StringType());
            query.addScalar("status", new ShortType());
            query.addScalar("recordStatus", new ShortType());

            query.setResultTransformer(Transformers.aliasToBean(ContactCustResultDTO.class));

            int count = 0;
            list = query.list();
            if (list.size() > 0) {
                count = list.size();
            }
            Pageable pageable = SQLBuilder.buildPageable(dto);
            if (pageable != null) {
                query.setFirstResult(pageable.getPageNumber() * pageable.getPageSize());
                query.setMaxResults(pageable.getPageSize());
            }
            List<ContactCustResultDTO> data = query.list();
            for (ContactCustResultDTO contactCustResultDTO: data) {
                if (!"AGENT".equals(dto.getRoleUser())) {
                    contactCustResultDTO.setEnableEdit(true);
                } else {
                    if (contactCustResultDTO.getRecordStatus() == 2) {
                        contactCustResultDTO.setEnableEdit(true);
                    } else if (contactCustResultDTO.getRecordStatus() == 1 && isLower24Hour(contactCustResultDTO.getCreateTime())){
                        contactCustResultDTO.setEnableEdit(true);
                    } else {
                        contactCustResultDTO.setEnableEdit(false);
                    }
                }
            }
            Page<ContactCustResultDTO> dataPage = new PageImpl<>(data, pageable, count);
            resultDTO.setData(dataPage);
            resultDTO.setErrorCode(Constants.ApiErrorCode.SUCCESS);
            resultDTO.setDescription(Constants.ApiErrorDesc.SUCCESS);
        } catch (Exception e) {
            resultDTO.setErrorCode(Constants.ApiErrorCode.ERROR);
            resultDTO.setDescription(Constants.ApiErrorDesc.ERROR);
            logger.error(e.getMessage(), e);
        } finally {
            session.close();
            return resultDTO;
        }
    }

    @Override
    public List<ContactCustResultDTO> getExcelInteractiveResult(CampaignRequestDTO dto) {
        List<ContactCustResultDTO> list = new ArrayList<>();
        SessionFactory sessionFactory = HibernateUtil.getSessionFactory();
        Session session = sessionFactory.openSession();
        session.beginTransaction();

        StringBuilder sqlBuilder = new StringBuilder();
        try {
            String sql = SQLBuilder.getSqlQueryById(Constants.SQL_MODULES.MODULE_EXECUTE, "get-execute-interactive");
            sqlBuilder.append(sql);

            sqlBuilder.append(" and b.campaign_type in (:p_list_compaign_type)");
            sqlBuilder.append(" and to_char(a.customer_id) like :p_customer_id");
            sqlBuilder.append(" and to_char(a.contact_status) in (:p_list_contact_status)");
            sqlBuilder.append(" and to_char(a.call_status) in (:p_list_survey_status)");
            sqlBuilder.append(" and to_char(a.status) in (:p_list_record_status)");

            if (!DataUtil.isNullOrEmpty(dto.getPhoneNumber())) {
                sqlBuilder.append(" and a.phone_number like :p_phone_number");
            }
            if (!DataUtil.isNullOrEmpty(dto.getCampaignId())) {
                sqlBuilder.append(" and b.campaign_code in (:p_list_campaign_id) ");
            }
            if (!DataUtil.isNullOrEmpty(dto.getCampaignName())) {
                sqlBuilder.append(" and upper(b.campaign_name) like :p_campaign_name");
            }
            if (!DataUtil.isNullOrEmpty(dto.getAgentId())) {
                sqlBuilder.append(" and upper(c.user_name) like :p_user_name");
            }

            SQLQuery query = session.createSQLQuery(sqlBuilder.toString());

            query.setParameter("p_company_site_id", dto.getCompanySiteId());
            query.setParameter("p_customer_id", "%" + dto.getCustomerId()
                    .replace("\\", "\\\\")
                    .replaceAll("%", "\\%")
                    .replaceAll("_", "\\_")
                    + "%");
            query.setParameter("p_date_from", dto.getFromDate());
            query.setParameter("p_date_to", dto.getToDate());
            query.setParameterList("p_list_compaign_type", dto.getCampaignType().split(","));
            query.setParameterList("p_list_contact_status", dto.getContactStatus().split(","));
            query.setParameterList("p_list_survey_status", dto.getSurveyStatus().split(","));
            query.setParameterList("p_list_record_status", dto.getRecordStatus().split(","));
            query.setParameter("p_call_time_from", dto.getCallTimeFrom());
            query.setParameter("p_call_time_to", dto.getCallTimeTo());

            if (!DataUtil.isNullOrEmpty(dto.getCampaignId())) {
                query.setParameterList("p_list_campaign_id", dto.getCampaignId().split(","));
            }
            if (!DataUtil.isNullOrEmpty(dto.getPhoneNumber())) {
                query.setParameter("p_phone_number", "%" + dto.getPhoneNumber()
                        .replace("\\", "\\\\")
                        .replaceAll("%", "\\%")
                        .replaceAll("_", "\\_")
                        + "%");
            }
            if (!DataUtil.isNullOrEmpty(dto.getCampaignName())) {
                query.setParameter("p_campaign_name", "%" + dto.getCampaignName().toUpperCase()
                        .replace("\\", "\\\\")
                        .replaceAll("%", "\\%")
                        .replaceAll("_", "\\_")
                        + "%");
            }
            if (!DataUtil.isNullOrEmpty(dto.getAgentId())) {
                query.setParameter("p_user_name", "%" + dto.getAgentId().toUpperCase()
                        .replace("\\", "\\\\")
                        .replaceAll("%", "\\%")
                        .replaceAll("_", "\\_")
                        + "%");
            }

            query.addScalar("campaignCode", new StringType());
            query.addScalar("campaignName", new StringType());
            query.addScalar("userName", new StringType());
            query.addScalar("phoneNumber", new StringType());
            query.addScalar("customerName", new StringType());
            query.addScalar("createTime", new DateType());
            query.addScalar("contactStatus", new StringType());
            query.addScalar("surveyStatus", new StringType());
            query.addScalar("status", new ShortType());
            query.addScalar("recordStatus", new ShortType());

            query.setResultTransformer(Transformers.aliasToBean(ContactCustResultDTO.class));

            list = query.list();
        } catch (Exception e) {
            logger.error(e.getMessage(), e);
        } finally {
            session.close();
            return list;
        }
    }

    private boolean isLower24Hour(Date createTime) {
        Date currTime = new Date();
        long diffMilSec = currTime.getTime() - createTime.getTime();
        long hour = TimeUnit.MILLISECONDS.toHours(diffMilSec);
        if (hour > 24) return false;
        return true;
    }


}
